/*
  Adapted from "A Book On C", 2nd Edition,
  by Al Kelly & Ira Pohl,
  Section 6.14 Ragged Arrays,
  page 226
*/
#include <stdio.h>

int main(void)
{
   // Explain EXACTLY how these variables are allocated!
   char  a[][15] = {"cat", "i am not a cat"};
   char *p[]     = {"dog", "i am not a dog"};

   printf("%c%c%c\n", a[0][0], a[0][1], a[0][2]);
   printf("%c%c%c\n", p[0][0], p[0][1], p[0][2]);
   printf("%s\n", a[1]);
   printf("%s\n", p[1]);

   a[0][0] = a[1][11] = 'h';
   printf("%c%c%c\n", a[0][0], a[0][1], a[0][2]);
   printf("%s\n", a[1]);

   p[0][0] = p[1][11] = 'h';  // this doesn't work
   printf("%c%c%c\n", p[0][0], p[0][1], p[0][2]);
   printf("%s\n", p[1]);

   return 0;
}
