/*
   Unlike C, Java has only one way to create an array of objects.

   https://cscircles.cemc.uwaterloo.ca/java_visualize/
*/

class MyClass
{
   int w, x, y, z;

   public MyClass(int w_, int x_, int y_, int z_)
   {
      w=w_; x=x_; y=y_; z=z_;
   }
}


public class Array_of_Objects
{
   public static void f(MyClass[] x)
   {
      int y0 = x[0].y;
      int y1 = x[1].y;
      int y2 = x[2].y;
      System.out.printf("in f, x[0].y = %d\n", y0);
      System.out.printf("in f, x[1].y = %d\n", y1);
      System.out.printf("in f, x[2].y = %d\n", y2);
   }


   public static void main(String[] args)
   {
      MyClass[] array4 = new MyClass[3];
      array4[0] = new MyClass(71,72,73,74);
      array4[1] = new MyClass(81,82,83,84);
      array4[2] = new MyClass(91,92,93,94);

      f(array4);
   }
}