/*
   There are several ways to create a 2-dim array of structs.
*/
#include <stdio.h>
#include <stdlib.h>

struct MyType {
   int w;
   int x;
   int y;
   int z;
};

void f(struct MyType x[][2]) // x can have any number of rows but must have 2 columns
{
   int y00 = x[0][0].y;
   int y01 = x[0][1].y;
   int y10 = x[1][0].y;
   int y11 = x[1][1].y;
   printf("in f, x[0][0].y = %d\n", y00);
   printf("in f, x[1][1].y = %d\n", y01);
   printf("in f, x[1][0].y = %d\n", y10);
   printf("in f, x[1][0].y = %d\n", y11);
}


void g(struct MyType **x)
{
   int y00 = x[0][0].y;
   int y01 = x[0][1].y;
   int y10 = x[1][0].y;
   int y11 = x[1][1].y;
   printf("in f, x[0][0].y = %d\n", y00);
   printf("in f, x[1][1].y = %d\n", y01);
   printf("in f, x[1][0].y = %d\n", y10);
   printf("in f, x[1][0].y = %d\n", y11);
}


int main(void)
{
   struct MyType array1[2][2] = {{{11,12,13,14}, {21,22,23,24}},
                                 {{31,32,33,34}, {41,42,43,44}}};

//   struct MyType *array2 = (struct MyType*)malloc(4 * sizeof(struct MyType));
//   array2[0][0].y = 53;
//   array2[0][1].y = 63;
//   array2[1][0].y = 73;
//   array2[1][1].y = 83;

   f(array1);
   g(array1);

   return 0;
}
